<?php

if ( ! class_exists( 'GFForms' ) ) {
	die();
}

class GF_Field_Peach_CreditCard extends GF_Field {

	public $type = 'peach_creditcard';
	
	public function get_form_editor_field_title() {
		return esc_attr__( 'Peach Credit Card', 'gravityforms' );
	}
	
	public function get_form_editor_button() {
		return array(
			'group' => 'pricing_fields',
			'text'  => $this->get_form_editor_field_title()
		);
	}
	
	function get_form_editor_field_settings() {
		return array(
			'label_setting'
		);
	}
	
	public function is_conditional_logic_supported() {
		return false;
	}
	
	public function get_field_input( $form, $value = '', $entry = null ) {
		$form_id         = $form['id'];
		$id              = (int) $this->id;
	 
		$input = '
		<div class="ginput_container">
			<div id="payment-form"></div>
			<script src="https://sandbox-checkout.peachpayments.com/js/checkout.js"></script>
			<input name="input_'.$id.'" id="input_'.$form_id .'_'.$id.'" type="hidden" value=""/>
		</div>
		';
	 
		return $input;
	}
	
	//Front-end script render
	public function get_form_inline_script_on_page_render( $form ) {
		$script = '';
		//https://dashboard.peachpayments.com
		//https://sandbox-dashboard.peachpayments.com
		
		$curl = curl_init();

		curl_setopt_array($curl, array(
			CURLOPT_URL => 'https://sandbox-dashboard.peachpayments.com/api/oauth/token',
			CURLOPT_RETURNTRANSFER => true,
			CURLOPT_ENCODING => '',
			CURLOPT_MAXREDIRS => 10,
			CURLOPT_TIMEOUT => 0,
			CURLOPT_FOLLOWLOCATION => true,
			CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
			CURLOPT_CUSTOMREQUEST => 'POST',
			CURLOPT_POSTFIELDS =>'{
			"clientId": "9549d4fea3cace5174166acf53449b",
			"clientSecret": "9sIK9/CjPDenX2M2nw9pZJC9sM87N4aOJ2l4zY91T1n+RwGpYzCdXot2OWdExrKQS551H/4GAsvxjhBqnsgH6g==",
			"merchantId": "dfb8f0f184ef11ec9ae902d14de18c0c"
			}',
			CURLOPT_HTTPHEADER => array(
				'Content-Type: application/json'
			),
		));

		$access_response = curl_exec($curl);
		
		//$script .= 'console.log('.$access_response.');';

		curl_close($curl);

		$access_result = json_decode($access_response);
		$access_token = $access_result->access_token;
		
		$nonce = wp_create_nonce( $form['id'].'_'.time() );
		
		$curl = curl_init();
		curl_setopt_array($curl, array(
		  CURLOPT_URL => 'https://testsecure.peachpayments.com/v2/checkout',
		  CURLOPT_RETURNTRANSFER => true,
		  CURLOPT_ENCODING => '',
		  CURLOPT_MAXREDIRS => 10,
		  CURLOPT_TIMEOUT => 0,
		  CURLOPT_FOLLOWLOCATION => true,
		  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		  CURLOPT_CUSTOMREQUEST => 'POST',
		  CURLOPT_POSTFIELDS =>'{
			"authentication": {
				"entityId": "8ac7a4c87ebe33f9017ebfb84b2304d7"
			},
			"amount":307.01,
			"currency":"ZAR",
			"shopperResultUrl": "https://peach8.semantica.co.za",
			"merchantTransactionId": "Checkout_eCGocX0bmw34mUX",
			"nonce": "{{autoNonce}}",
			"notificationUrl": "",
			"cancelUrl": "",
			"merchantInvoiceId": "INV-Uqa6piETRW2A51e",
			"customer": {
				"merchantCustomerId": "335",
				"givenName": "Santa",
				"surname": "Hessel",
				"mobile": "319-628-3395",
				"email": "Kianna26@hotmail.com",
				"idNumber":"1111111111111"
			},
			"billing": {
				"street1": "791 Burdette Burgg",
				"street2": "07308 Erica Meadow",
				"city": "Jaskolskimouth",
				"company": "Wiza Inc",
				"country": "FI",
				"state": "WC",
				"postcode": "3674"
			},
			"shipping": {
				"street1": "9316 Hayes Mill",
				"street2": "976 Emmerich Stravenue",
				"city": "Swaniawskihaven",
				"company": "Sawayn, Lueilwitz and Gusikowski",
				"country": "GM",
				"state": "WC",
				"postcode": "7923"
			},
			"defaultPaymentMethod": "",
			"forceDefaultMethod": false,
			"createRegistration": false
		}',
		  CURLOPT_HTTPHEADER => array(
			'Origin: https://peach8.semantica.co.za',
			'Referer: https://peach8.semantica.co.za/',
			'Content-Type: application/json',
			'Authorization: Bearer '.$access_token
		  ),
		));
		$response = curl_exec($curl);
		curl_close($curl);
		
		$result = json_decode($response);
		$checkout_token = $result->checkoutId;
		
		//$script .= 'console.log('.$response.');';
		
		$script .= '
		const checkout = Checkout.initiate({
			key: "8ac7a4c87ebe33f9017ebfb84b2304d7",
			checkoutId: "'.$checkout_token.'",
		});
		
		checkout.render("#payment-form");
		';

		return $script;
	}
	
	
	//Back-end validation
	public function get_form_editor_inline_script_on_page_render() {
		return "
		gform.addFilter('gform_form_editor_can_field_be_added', function (canFieldBeAdded, type) {
			if (type == 'peach_creditcard') {
				if (GetFieldsByType(['product']).length <= 0) {
					alert(" . json_encode( esc_html__( 'You must add a Product field to the form', 'gravityformspeachpayments' ) ) . ");
					return false;
				} else if (GetFieldsByType(['total']).length  <= 0) {
					alert(" . json_encode( esc_html__( 'You must add a Total field to the form', 'gravityformspeachpayments' ) ) . ");
					return false;
				} else if (GetFieldsByType(['peach_creditcard']).length || GetFieldsByType(['creditcard']).length) {
					alert(" . json_encode( esc_html__( 'Only one credit card field can be added to the form', 'gravityformspeachpayments' ) ) . ");
					return false;
				}
			}
			return canFieldBeAdded;
		});";
	}
}

GF_Fields::register( new GF_Field_Peach_CreditCard() );
