<?php
/**
 * Plugin Name: Gravity Forms Peach Payments Gateway Add-On
 * Plugin URI: https://peachpayments.com
 * Description: Integrates Gravity Forms with Peach Payments Gateway, enabling end users to purchase goods and services through Gravity Forms.
 * Version: 1.0.0
 * Author: Peach Payments
 * Author URI: https://peachpayments.com
 * License: GPL-2.0+
 * Text Domain: gravityformspeachpayments
 * Requires at least: 4.7
 * Tested up to: 6.0
 */

defined( 'ABSPATH' ) || die();

if( ! function_exists('get_plugin_data') ){
	require_once( ABSPATH . 'wp-admin/includes/plugin.php' );
}

$plugin_data = get_plugin_data( __FILE__ );

define( 'GF_PEACHPAY_VER', $plugin_data['Version'] );
define( 'GF_PEACH_SITE_URL', get_site_url().'/' );

// If Gravity Forms is loaded
add_action( 'gform_loaded', 'GF_PeachPay_Funct', 10, 0 );

add_filter( 'gform_countries', function ( $countries ) {
    $new_countries = array();
 
    foreach ( $countries as $country ) {
        $code                   = GF_Fields::get( 'address' )->get_country_code( $country );
        $new_countries[ $code ] = $country;
    }
 
    return $new_countries;
} );

//Handles the loading of the Peach Payments Add-On and registers with the Add-On framework.
function GF_PeachPay_Funct() {

		if ( ! method_exists( 'GFForms', 'include_payment_addon_framework' ) ) {
			return;
		}

		require_once( 'class-gf-peach.php' );

		GFAddOn::register( 'GFPeach' );

}

//Obtains and returns an instance of the GFPeach class
function gf_peach() {
	return GFPeach::get_instance();
}
